设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 67|回复: 1

[求助] 现在文字递增是一个一个点过去的,求超级文字递增

[复制链接]
发表于 2020-7-29 20:59:07 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
想请大师帮忙弄一下怎么样才能让一个数字超级递增,图一是一个一个点,图二,是超级递增的,求图二的效果
这是图一的码源

图一

图一
            

图二

图二

(defun c:ttc (/ origent origentdata origtext numtext prefixlen prefix num
           cmd addn pt1 pt2 newdata txt
        )
   (setq copyincolderrorfunc *error*)
  (setq *error* copyincerrorfunc)
  (command "_.undo" "_Group")
  (setq cmd (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (while (= origent nil)
    (setq origent (entsel "\n选择文本: "))
  )
  (setq txt (car origent))
  (setq origentdata (cdr (entget (car origent))))
  (if (/= (cdr (assoc 0 origentdata)) "TEXT")
    (princ "未选择文本.")
    (progn
      (setq origtext (cdr (assoc 1 origentdata)))
      (setq numtext (getsuffixdigits origtext))
      (if (= numtext "")
    (princ "此文本不是以数字结尾")
    (progn
      (setq prefixlen (- (strlen origtext) (strlen numtext)))
      (if (= prefixlen 0)
        (setq prefix "")
        (setq prefix (substr origtext 1 prefixlen))
      )
      (setq num (atoi numtext))
      (setq addn (getint "\n请输入增值(默认为1): "))
      (if (= addn nil)
        (setq addn 1)
      )
      (setq pt1 (getpoint "\n基准点:"))
      (setq pt2 0)
      (while (progn
           (initget 128)
           (setq pt2 (getpoint pt1 "\n拷贝至 (点回车键退出): "))
         )
        (if (/= pt2 nil)
          (progn
        (setq num (+ num addn))
        (setq num (itoa num))
        (setq newdata (strcat prefix num))
        (command "copy" txt "" pt1 pt2)
        (command "change" (entlast) "" "" "" "" "" "" newdata)
        (setq num (atoi num))
          )
        )
      )
    )
      )
    )
  )
  (setq *error* copyincolderrorfunc)
  (princ)
  (setvar "cmdecho" cmd)
  (command "_.undo" "_end")
)
(defun getsuffixdigits (origstr / digits prefixlen char)
  (setq digits "")
  (setq prefixlen (strlen origstr))
  (while (> prefixlen 0)
    (setq char (substr origstr prefixlen 1))
    (if (wcmatch char "#")
      (progn
    (setq digits (strcat char digits))
    (setq prefixlen (1- prefixlen))
      )
      (setq prefixlen 0)
    )
  )
  (setq digits digits)
)
(setq copyincolderrorfunc nil)
(defun copyincerrorfunc (msg)
  (if (= msg "function cancelled")
    (princ " ")
    (if (= msg "quit / exit abort")
      (princ " ")
      (princ (strcat "\nerror: " msg))
    )
  )
  (setq *error* copyincolderrorfunc)
  (princ)
)


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 19个

财富等级: 恭喜发财

发表于 2020-7-29 22:03:27 | 显示全部楼层
增强的拷贝+1(第三版
148 个回复 - 3467 次查看
支持曲线阵列的第二版发布,见:http://bbs.xdcad.net/thread-716036-1-1.html 第三版加入了多选+1功能,+1依据多选的文字里面数字最大的开始编号,拷贝数量为多选的文字个数。点右上角演示放大观看。 ...
2018-7-16 18:28 - newer - 每日插件


                               
登录/注册后可看大图



                               
登录/注册后可看大图


                               
登录/注册后可看大图

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-8-12 10:56 , Processed in 0.130171 second(s), 28 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表